# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch: %{ix86}

# switched to clang due to gcc LTO bug
# https://gcc.gnu.org/bugzilla/show_bug.cgi?id=114501
%bcond_with toolchain_clang

%global uuid com.chatterino.chatterino
%global chatterino_git_commit 3f3a31db4ddf3b634eff78b3201f15e6b8ce7b14
%global chatterino_git_shortcommit %(c=%{chatterino_git_commit}; echo ${c:0:7})
%global tarball_version %%(echo %{version} | tr '~' '-')%{?tarball_version_extra}
#global tarball_version_extra -beta.1

%if %{without toolchain_clang}
%global toolchain clang
%endif


# Git submodules
# https://github.com/Chatterino/libcommuni , Branch: chatterino-cmake
%global version2        3.7.0
%global commit2         2979eb96262756047a8dca47f2e509168138c0d0
%global shortcommit2    %(c=%{commit2}; echo ${c:0:7})

# https://github.com/pajlada/settings
# settings
# updated rel 2.4.3
%global version3        0.3.0
%global commit3         c141a40d2d493646cd8f0b1e06251a828dfdfdd2
%global shortcommit3    %(c=%{commit3}; echo ${c:0:7})

# https://github.com/pajlada/signals
# signals
# updated rel 2.4.3
%global version4        0.1.0
%global commit4         d06770649a7e83db780865d09c313a876bf0f4eb
%global shortcommit4    %(c=%{commit4}; echo ${c:0:7})

# https://github.com/pajlada/serialize
# serialize
# updated rel 2.4.3
%global commit5         17946d65a41a72b447da37df6e314cded9650c32
%global shortcommit5    %(c=%{commit5}; echo ${c:0:7})

# https://github.com/martinmoene/expected-lite
# expected-lite 
# new dep 2.5.2
%global commit6         54ca18bcea8e39c41650d82268077d559c695aa5
%global shortcommit6    %(c=%{commit6}; echo ${c:0:7})

# https://github.com/ThePhD/sol2
#   *  Sol2 ( needed for plugins )
%global version7        3.3.0
%global commit7         2b0d2fe8ba0074e16b499940c4f3126b9c7d3471
%global shortcommit7    %(c=%{commit7}; echo ${c:0:7})

# https://github.com/lua/lua 
# lua
%global version8        5.4.7
%global commit8         1ab3208a1fceb12fca8f24ba57d6e13c5bff15e3
%global shortcommit8    %(c=%{commit8}; echo ${c:0:7})

# https://github.com/Neargye/magic_enum
# magic_enum
%global version9        0.9.7
%global commit9         1a1824df7ac798177a521eed952720681b0bf482
%global shortcommit9    %(c=%{commit9}; echo ${c:0:7})

# https://github.com/arsenm/sanitizers-cmake
# sanitizers-cmake
%global commit10        0573e2ea8651b9bb3083f193c41eb086497cc80a
%global shortcommit10   %(c=%{commit10}; echo ${c:0:7})

# https://github.com/Chatterino/certify
# certify ( needed for EventSub Support )
%global commit11         a448a3915ddac716ce76e4b8cbf0e7f4153ed1e2
%global shortcommit11    %(c=%{commit11}; echo ${c:0:7})


Name:           chatterino2
Version:        2.5.3
Release:        1%{?dist}
Summary:        Chat client for https://twitch.tv

# Boost Software License (v1.0) Boost Software License 1.0
# -----------------------------------------------------------------------
# resources/licenses/boost_boost.txt
#
# BSD 3-clause "New" or "Revised" License
# ---------------------------------------
# lib/libcommuni/
#
# Expat License
# -------------
# lib/serialize/
# lib/signals/
# resources/
#
# Mozilla Public License (v1.1) GNU General Public License (v2 or later) or GNU Lesser General Public License (v2.1 or later)
# ---------------------------------------------------------------------------------------------------------------------------
# lib/libcommuni/
#
# zlib/libpng license Aladdin Free Public License
# -----------------------------------------------
# lib/websocketpp/
#
License:        MIT and BSL-1.0 and BSD-3-Clause and zlib and GPL-2.0-or-later and LGPL-2.1-or-later and MPL-1.1

URL:            https://github.com/Chatterino/chatterino2
Source0:        %{url}/archive/v%{tarball_version}/%{name}-%{tarball_version}.tar.gz
Source2:        https://github.com/Chatterino/libcommuni/archive/%{commit2}/libcommuni-%{shortcommit2}.tar.gz
Source3:        https://github.com/pajlada/settings/archive/%{commit3}/settings-%{shortcommit3}.tar.gz
Source4:        https://github.com/pajlada/signals/archive/%{commit4}/signals-%{shortcommit4}.tar.gz
Source5:        https://github.com/pajlada/serialize/archive/%{commit5}/serialize-%{shortcommit5}.tar.gz
Source6:        https://github.com/martinmoene/expected-lite/archive/%{commit6}/expected-lite-%{shortcommit6}.tar.gz
Source7:        https://github.com/ThePhD/sol2/archive/%{commit7}/sol2-%{shortcommit7}.tar.gz
Source8:        https://github.com/lua/lua/archive/%{commit8}/lua-%{shortcommit8}.tar.gz
Source9:        https://github.com/Neargye/magic_enum/archive/%{commit9}/magic_enum-%{shortcommit9}.tar.gz
Source10:       https://github.com/arsenm/sanitizers-cmake/archive/%{commit10}/sanitizers-cmake-%{shortcommit10}.tar.gz
Source11:       https://github.com/Chatterino/certify/archive/%{commit11}/certify-%{shortcommit11}.tar.gz

BuildRequires:  boost-devel
BuildRequires:  cmake
BuildRequires:  desktop-file-utils
BuildRequires:  libappstream-glib
BuildRequires:  make

%if %{without toolchain_clang}
BuildRequires:  clang
%else
BuildRequires:  gcc-c++
%endif

BuildRequires:  cmake(Qt6Concurrent)
BuildRequires:  cmake(Qt6Core)
BuildRequires:  cmake(Qt6Gui)
BuildRequires:  cmake(Qt6Keychain)
BuildRequires:  cmake(Qt6LinguistTools)
BuildRequires:  cmake(Qt6Multimedia)
BuildRequires:  cmake(Qt6Network)
BuildRequires:  cmake(Qt6Svg)
BuildRequires:  cmake(Qt6Widgets)
BuildRequires:  cmake(Qt6Core5Compat)
BuildRequires:  cmake(RapidJSON)

BuildRequires:  pkgconfig(libsecret-1)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(websocketpp)
BuildRequires:  miniaudio-devel
BuildRequires:  pkgconfig(xkbcommon)
# notify support since 2.5.3
BuildRequires:  pkgconfig(libnotify)

Requires:       hicolor-icon-theme
Requires:       qt6-qtsvg
Requires:       qt6-qtimageformats

# Current submodules patched so not possible to build with system packages
#   * https://github.com/Chatterino/chatterino2/issues/1444
Provides:       bundled(libcommuni) = %{version2}~git%{shortcommit2}
Provides:       bundled(magic_enum) = %{version9}~git%{shortcommit9}
Provides:       bundled(sanitizers-cmake) = 0~git%{shortcommit10}
Provides:       bundled(serialize) = 0~git%{shortcommit5}
Provides:       bundled(settings) = %{version3}~git%{shortcommit3}
Provides:       bundled(signals) = %{version4}~git%{shortcommit4}
Provides:       bundled(Sol2) = %{version7}~git%{shortcommit7}
Provides:       bundled(lua) =  %{version8}~git%{shortcommit8}
Provides:       bundled(expected-lite) = 0~git%{shortcommit6}
Provides:       bundled(certify) = 0~git%{shortcommit11}

%description
Chatterino 2 is a chat client for Twitch.tv.


%prep
%setup -n %{name}-%{tarball_version} -q
%setup -n %{name}-%{tarball_version} -q -D -T -a2
%setup -n %{name}-%{tarball_version} -q -D -T -a3
%setup -n %{name}-%{tarball_version} -q -D -T -a4
%setup -n %{name}-%{tarball_version} -q -D -T -a5
%setup -n %{name}-%{tarball_version} -q -D -T -a6
%setup -n %{name}-%{tarball_version} -q -D -T -a7
%setup -n %{name}-%{tarball_version} -q -D -T -a8
%setup -n %{name}-%{tarball_version} -q -D -T -a9
%setup -n %{name}-%{tarball_version} -q -D -T -a10
%setup -n %{name}-%{tarball_version} -q -D -T -a11

mv libcommuni-%{commit2}/*    lib/libcommuni
mv settings-%{commit3}/*      lib/settings
mv signals-%{commit4}/*       lib/signals
mv serialize-%{commit5}/*     lib/serialize
mv expected-lite-%{commit6}/* lib/expected-lite
mv sol2-%{commit7}/*          lib/sol2
mv lua-%{commit8}/*           lib/lua/src
mv magic_enum-%{commit9}/*    lib/magic_enum
mv sanitizers-cmake-%{commit10}/* cmake/sanitizers-cmake
mv certify-%{commit11}/*      lib/certify


%build
export GIT_COMMIT=%{chatterino_git_commit}
export GIT_HASH=%{chatterino_git_shortcommit}
export GIT_RELEASE=%{version}
%cmake \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DBUILD_WITH_QT6=ON \
    -DUSE_PRECOMPILED_HEADERS=0FF \
    -DUSE_SYSTEM_QTKEYCHAIN=ON \
    -DBUILD_WITH_QTKEYCHAIN=ON \
    -DUSE_SYSTEM_MINIAUDIO=ON \
    -DCHATTERINO_UPDATER=OFF \
    -DCHATTERINO_LTO=ON \
    -DCHATTERINO_PLUGINS=ON \
    %{nil}
%cmake_build


%install
%cmake_install
install -Dpm 0644 resources/%{uuid}.appdata.xml   \
    %{buildroot}%{_metainfodir}/%{uuid}.appdata.xml
install -Dpm 0644 resources/icon.png              \
    %{buildroot}%{_datadir}/icons/hicolor/256x256/apps/chatterino.png


%check
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/*.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/*.desktop


%files
%license LICENSE
%doc README.md BUILDING_ON_LINUX.md docs/
%{_bindir}/chatterino
%{_datadir}/applications/*.desktop
%{_datadir}/icons/hicolor/*/*/*.png
%{_metainfodir}/*.xml

%changelog
* Sun Mar 23 2025 Christian Birk <mail@birkc.de> - 2.5.3-1
- new version

* Mon Jan 06 2025 Christian Birk <mail@birkc.de> - 2.5.2-2
- rebuild for full release
- enable plugin api

* Mon Jan 06 2025 Christian Birk <mail@birkc.de> - 2.5.2-1
- new version - beta.1

